//  *****************
//  ***   Blood   ***
//  *****************
// Modify the internal Blood actor to spawn flying blood
actor NashGore_Blood : Blood replaces Blood
{
	game Doom
	states
	{
	Spawn:
		BLUD C 8
		BLUD B 8 A_SpawnDebris("NashGore_FlyingBlood",1)
		BLUD A 8
//		stop
	Pain:
		PUFF A 0 bright A_Playsound("bld/splt")
		stop
	}
}

//  *********************
//  ***   Blood red   ***
//  *********************
actor NashGore_FlyingBlood
{
	game Doom
	scale 0.75
	health 1
	radius 8
	height 1
	mass 1
	+CORPSE +NOTELEPORT +NOBLOCKMAP// +CANBOUNCEWATER
	states
	{
	Spawn:
		TNT1 A 0
		FBLD A 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD A 1
		FBLD A 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD A 1
		FBLD B 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD B 1
		FBLD B 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD B 1
		FBLD C 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD C 1
		FBLD C 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD C 1
		FBLD D 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD D 1
		FBLD D 1 A_SpawnItem("NashGore_FlyingBloodTrail",0,0,0,1)
		FBLD D 1
		loop
	Crash:
		TNT1 A 1 A_SpawnItem("NashGore_BloodSpot",0,0,0,1)
		stop
	}
}

actor NashGore_BloodSpot
{
	game Doom
	radius 12
	height 2
	mass 1
	+NOTELEPORT
	-NOBLOCKMAP
	states
	{
	Spawn:
		TNT1 A 0
		TNT1 A 0 A_PlaySound("bloodsplat")
		TNT1 A 0 A_Jump(64,4)
		TNT1 A 0 A_Jump(128,4)
		TNT1 A 0 A_Jump(192,4)
		TNT1 A 0 A_Jump(255,4)
		// make the blood spots stay on the ground. 1500 is the default duration.
		BSPT A 1500
		stop
		BSPT B 1500
		stop
		BSPT C 1500
		stop
		BSPT D 1500
		stop
	}
}

// Blood trails spawned by FlyingBlood
actor NashGore_FlyingBloodTrail
{
	game Doom
	scale 0.70
	mass 1
	+LOWGRAVITY
	+NOTELEPORT
	+NOBLOCKMAP
	states
	{
	Spawn:
		BTRL A 4
		BTRL B 4
		BTRL C 4
		BTRL D 4
		stop
	}
}

//  ***********************
//  ***   Blood green   ***
//  ***********************
actor gFlyingBlood
{
	game Doom
	scale 0.75
	health 1
	radius 8
	height 1
	mass 1
	+CORPSE
	+NOTELEPORT
	+NOBLOCKMAP
	states
	{
	Spawn:
		TNT1 A 0
		FBLG A 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG A 1 
		FBLG A 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG A 1
		FBLG B 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG B 1
		FBLG B 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG B 1
		FBLG C 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG C 1
		FBLG C 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG C 1
		FBLG D 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG D 1
		FBLG D 1 A_SpawnItem("gFlyingBloodTrail",0,0,0,1)
		FBLG D 1
		loop
	Crash:
		NULL A 1 A_SpawnItem("gBloodSpot",0,0,0,1)
		stop
	}
}

actor gBloodSpot
{
	game Doom
	radius 12
	height 2
	mass 1
	+NOTELEPORT
	-NOBLOCKMAP
	states
	{
	Spawn:
		NULL A 0
		NULL A 0 A_PlaySound("bloodsplat")
		NULL A 0 A_Jump(64,4)
		NULL A 0 A_Jump(128,4)
		NULL A 0 A_Jump(192,4)
		NULL A 0 A_Jump(255,4)
		// make the blood spots stay on the ground. 1500 is the default duration.
		BSPG A 1500
		stop
		BSPG B 1500
		stop
		BSPG C 1500
		stop
		BSPG D 1500
		stop
	}
}

// Blood trails spawned by FlyingBlood
actor gFlyingBloodTrail
{
	game Doom
	scale 0.70
	mass 1
	+LOWGRAVITY
	+NOTELEPORT
	+NOBLOCKMAP
	states
	{
	Spawn:
		BTRG A 4
		BTRG B 4
		BTRG C 4
		BTRG D 4
		stop
	}
}

//  **********************
//  ***   Blood blue   ***
//  **********************
actor bFlyingBlood
{
	game Doom
	scale 0.75
	health 1
	radius 8
	height 1
	mass 1
	+CORPSE
	+NOTELEPORT
	+NOBLOCKMAP
	states
	{
	Spawn:
		TNT1 A 0
		FBLB A 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB A 1 
		FBLB A 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB A 1
		FBLB B 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB B 1
		FBLB B 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB B 1
		FBLB C 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB C 1
		FBLB C 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB C 1
		FBLB D 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB D 1
		FBLB D 1 A_SpawnItem("bFlyingBloodTrail",0,0,0,1)
		FBLB D 1
		loop
	Crash:
		NULL A 1 A_SpawnItem("bBloodSpot",0,0,0,1)
		stop
	}
}

actor bBloodSpot
{
	game Doom
	radius 12
	height 2
	mass 1
	+NOTELEPORT
	-NOBLOCKMAP
	states
	{
	Spawn:
		NULL A 0
		NULL A 0 A_PlaySound("bloodsplat")
		NULL A 0 A_Jump(64,4)
		NULL A 0 A_Jump(128,4)
		NULL A 0 A_Jump(192,4)
		NULL A 0 A_Jump(255,4)
		// make the blood spots stay on the ground. 1500 is the default duration.
		BSPB A 1500
		stop
		BSPB B 1500
		stop
		BSPB C 1500
		stop
		BSPB D 1500
		stop
	}
}

// Blood trails spawned by FlyingBlood
actor bFlyingBloodTrail
{
	game Doom
	scale 0.70
	mass 1
	+LOWGRAVITY
	+NOTELEPORT
	+NOBLOCKMAP
	states
	{
	Spawn:
		BTRB A 4
		BTRB B 4
		BTRB C 4
		BTRB D 4
		stop
	}
}
