//  ********************************************************
//  ***  Weapon: Magic hands (lighting)                  ***
//  ***  By: Cobalt and Butcher                          ***
//  ********************************************************
actor MagicHandsLightingPickup : CustomInventory
{
	Scale 0.2
	Inventory.PickupSound "misc/W_pkup"
	Inventory.PickUpMessage "You found a lighting spell scroll."
	+FLOATBOB
	states
	{
		Spawn:
			SPL4 A -1
			Loop
		Pickup:
			TNT1 A 0 A_JumpIfInventory("MagicHandsLighting", 1, 3)
			TNT1 A 0 A_GiveInventory("MagicHandsLighting", 1)
			TNT1 A 0 A_GiveInventory("Darkmana", 20)
			stop
			TNT1 A 0 A_GiveInventory("Darkmana", 20)
			TNT1 A 0 A_SpawnItemEx("MagicHandsLightingPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
actor MagicHandsLightingPickupEmpty : MagicHandsLightingPickup
{
	states
	{
		Pickup:
			TNT1 A 0 A_JumpIfInventory("MagicHandsLighting", 1, 1)
			TNT1 A 0 A_GiveInventory("MagicHandsLighting", 1)
			stop
			TNT1 A 0 A_SpawnItemEx("MagicHandsLightingPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
ACTOR MagicHandsLighting : Weapon 25004
{
	Tag "Magic Lighting"
	Scale 0.2
	weapon.selectionorder 2900
	Weapon.AmmoType "Darkmana"
//	Weapon.AmmoGive 20
	Weapon.AmmoUse 1
	Weapon.AmmoType2 "Darkmana"
	Weapon.AmmoUse2 25
	+FLOATBOB
//	+WEAPON.DONTBOB
	States
	{
		Spawn:
			SPL4 A 0
			SPL4 A 1 A_SpawnItem("MagicHandsLightingPickup")
			Stop
		Ready:
			TNT1 A 0 A_JumpIfInventory("DropAmmo",1,"DropAmmo_Start")
			TNT1 A 0 A_JumpIfInventory("DropWeapon",1,"DropWeapon_Start")
//			NULL A 1 A_WeaponReady
			SPLH H 2 A_WeaponReady
			TNT1 A 0 A_Jump(4, 1)
			Loop
			SPLH IJKLMNO 4 A_WeaponReady
			Loop
		Deselect:
			SPLH H 1 A_Lower
			NULL A 0 A_Lower
			goto Deselect// + 2
		Select:
			//goto Ready
			SPLH H 1 A_Raise
			Loop
		Fire:
			SPLH A 0 A_Checkreload
//			SPLH ABCDEFG 3
			SPLH HI 3
			SPLH I 0 A_PlayWeaponSound("weapons/firewand")
			SPLH I 0 A_FireCustomMissile("MagichandLightingShot_small",0,1,0,0)
			SPLH JK 3
			SPLH I 0 A_ReFire
//			SPLH GFEDCBA 3
			Goto Ready
		Hold:
			SPLH A 0 A_Checkreload
			SPLH LM 3
			SPLH M 0 A_PlayWeaponSound("weapons/firewand")
			SPLH M 0 A_FireCustomMissile("MagichandLightingShot_small",0,1,0,0)
			SPLH NO 3
			SPLH O 0 A_ReFire
//			SPLH GFEDCBA 3
			Goto Ready
		AltFire:
			SPLH A 0 A_Checkreload
//			SPLH ABCDEFG 3
			SPLH I 3
			SPLH I 0 A_PlayWeaponSound("weapons/firewand")
			SPLH I 0 A_FireCustomMissile("MagichandLightingShot_Big",0,1,0,0)
			SPLH JK 3
			SPLH LMNO 3
			SPLH I 0
//			SPLH GFEDCBA 3
			SPLH H 24
			Goto Ready
/* **********          Drop Ammo          ********** */
		DropAmmo_Start:
			TNT1 A 0 A_TakeInventory("DropAmmo", 1)
			TNT1 A 0 A_JumpIfInventory("Darkmana", 6, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("Darkmana", 6)
			TNT1 A 0 A_SpawnItemEx("SmallDarkmana", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			goto Ready
/* **********          Drop Weapon          ********** */
		DropWeapon_Start:
			TNT1 A 0 A_TakeInventory("DropWeapon", 1)
			TNT1 A 0 A_JumpIfInventory("MagicHandsLighting", 1, 1) // is weapon in inventory?
			goto Ready
			TNT1 A 0 A_SpawnItemEx("MagicHandsLightingPickupEmpty", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			TNT1 A 1 A_TakeInventory("MagicHandsLighting", 1)
			goto Deselect+1
	}
}
//  ********************************************************
//  ***  Weapon: MagicHandsLighting                      ***
//  ********************************************************
//  **********  **********
//  MagicHandsLighting
/* 
ACTOR MagichandLighting_1_Start
{
	+NOGRAVITY +RIPPER 
	Radius 3
	Height 3
	Speed 32
	Scale 0.5
	PROJECTILE
	States
	{
		Spawn:
			NULL A 4
			goto Death
		Death:
			NULL A 0 A_CustomMissile("MagichandLightingShot_1", 0, 0, Random(-4, 4))
			Stop
	}
}
*/ 
//  ********************************************************
//  ***  Weapon: MagicHandsLighting                      ***
//  ********************************************************
//  ********** Flash/Nova **********
//  MagicHandsLighting
ACTOR MagichandLightingShot_small //normal fire
{
	PROJECTILE
	damage 0
	Radius 8
	Height 8
	Speed 160
	Scale  1.0
	+NOGRAVITY +friendly
	States
	{
		Spawn:
			TNT1 A 1
			loop
		Death:
			TNT1 A 1 A_SpawnItem("MagichandLighting_small")
			Stop
	}
}
ACTOR MagichandLighting_small
{
	Scale 0.2
	Speed 0
	Damage 16
	RENDERSTYLE ADD
	+NOBLOCKMAP +BLOODLESSIMPACT +NOCLIP +MISSILE +RANDOMIZE +NOGRAVITY +RIPPER
	+missilemore +lookallaround +shortmissilerange +foilinvul
	States
	{
		Spawn:
			NOVA ABCDEFGHABCDEFGH 2 bright A_Explode(4, 64, 0)//A_Explode(3, 64, 0)
			Stop
	}
}
//  ********************************************************
//  ***  Weapon: MagicHandsLighting                      ***
//  ********************************************************
//  ********** Big Electricity Bolt **********
//  MagicHandsLighting
ACTOR MagichandLightingShot_Big //AltFire
{
//+CEILINGHUGGER
//+SPAWNCEILING
	PROJECTILE
	damage 0
	Radius 12
	Height 24
	Speed 8
	Scale 0.6
	+NOGRAVITY +RIPPER +friendly +missilemore +lookallaround +shortmissilerange +bloodlessimpact +foilinvul
	States
	{
		Spawn:
//			BFS1 ABAB 2 //A_Look
			BFS1 AB 2 A_CustomMissile("MagichandLightingShot_1", 0, 0, 0)//A_CustomMissile("MagichandLightingShot_1", 0, 0, Random(-127, 127))
			loop
//		see:
//			BFS1 ABABABAB 0
//			goto missile
//		missile:
//			BFS1 A 1 bright A_CustomRailgun (0, 0, "55 ff 88", "fd ff ff", 1, 0)
//			APLS B 0 bright A_CustomBulletAttack (0, 0, 1, 12, "BFGPuff")
//			APLS B 1 bright A_CustomBulletAttack (4, 4, 2, 6, "BFGPuff")
//			BFS1 A 1 //A_CustomMissile("MagichandLightingShot_1", 0, 0, 0)//A_CustomMissile("MagichandLightingShot_1", 0, 0, Random(-180, 180))
//			goto spawn
		Death:
			BFS1 ABABA 2 A_FadeOut(0.2)
			Stop
	}
}
ACTOR MagichandLightingShot_1
{
	Radius 3
	Height 3
	Speed 12
	Scale 0.5
	PROJECTILE
	+NOGRAVITY +RIPPER +BLOODLESSIMPACT
	States
	{
		Spawn:
			TNT1 A 0
			TNT1 A 1 A_Jump(254, 1)
			goto Death
			TNT1 A 0 A_CustomMissile("MagichandLightingShot_1", Random(-4, 4), 0, (Random(-32, 32) + 180), 0, 180)
			TNT1 A 0 A_SpawnItem("MagichandLighting")
			Goto Death
		Death:
			TNT1 A 0
			Stop
	}
}
ACTOR MagichandLighting
{
	+NOBLOCKMAP +BLOODLESSIMPACT +NOCLIP +MISSILE +RANDOMIZE +NOGRAVITY +RIPPER
	Scale 0.96
	Speed 0
	Damage 16
	RENDERSTYLE ADD
	States
	{
		Spawn:
			TNT1 A 0
			TNT1 A 0 A_Jump(32, 2)
			TNT1 A 0 A_SpawnItem("MagichandLighting_nolight")
			APLS CD 2 bright A_Explode(4, 32, 0)
			stop
			APLS CD 2 bright A_Explode(4, 32, 0)
			Stop
	}
}
ACTOR MagichandLighting_nolight : MagichandLighting
{
	States
	{
		Spawn:
			APLS CD 2 A_Explode(4, 32, 0)
			Stop
	}
}
//  ********************************************************
//  ***  Weapon: MagicHandsLighting                      ***
//  ********************************************************
//  ********** Big Electricity Bolt 2 **********
//  MagicHandsLighting
/* 
//in development
ACTOR MagichandLightingShot_Bigmonster
{ 
	Health 100 
	Radius 24 
	Height 52 
	Mass 200 
	Speed 0 
	MONSTER 
	+NOGRAVITY +FRIENDLY +FASTER +FASTMELEE +NOBLOCKMAP +NOCLIP +MISSILEMORE +NOTARGET +lookallaround +bloodlessimpact  +QUICKTORETALIATE
	States 
	{ 
	Spawn: 
		BFS1 A 0 Thing_Changetid(0,1998)
		BFS1 A 2 Thing_Damage(1998, 2, 0)
		BFS1 B 2 A_Jumpifcloser(300,1)
		loop	   
		BFS1 AB 2 A_Look 
		Goto See
	See: 
		BFS1 AB 2 A_Chase
		Goto See
	Missile: 
		BFS1 B 2 A_FaceTarget 
		BFS1 A 2 BRIGHT A_CustomMissile("MagichandLightingShot_1", 0, 0, 0, 0)
		BFS1 A 2 Thing_Damage(1998, 2, 0)
		Goto Spawn +1
	Death:
		BFS1 ABABA 2 A_FadeOut(0.2)
		Stop
	} 
}
ACTOR MagichandLightingShot_1
{
	Radius 3
	Height 3
	Speed 12
	Damage 2
	Scale 0.5
	PROJECTILE
	+NOGRAVITY +RIPPER +BLOODLESSIMPACT +friendly +lookallaround +QUICKTORETALIATE
	States
	{
		Spawn:
			TNT1 A 1 bright A_Explode(2, 16, 0)
		Goto See
		see:
			TNT1 A 0 A_Chase
			TNT1 A 1 A_Jump(254, 1)
			goto Death
			TNT1 A 0 A_FaceTarget
			TNT1 A 0 A_CustomMissile("MagichandLightingShot_1", Random(-4, 4), 0, (Random(-32, 32) + 180), 0, 0)
			TNT1 A 0 A_SpawnItem("MagichandLighting")
			Goto Death
		Death:
			TNT1 A 0
			Stop
	}
}
*/ 
