//  ********************************************************
//  ***  Weapon: Necronomicon                            ***
//  ***  By: Froon                                       ***
//  ***  Modified By: Cobalt and Butcher                 ***
//  ********************************************************
actor NecronomiconPickup : CustomInventory
{
	Scale 0.5
	Inventory.PickupSound "misc/W_pkup"
	Inventory.PickUpMessage "You got the Necronomicon!"
	+FLOATBOB
	states
	{
		Spawn:
			NCRO A -1
			Loop
		Pickup:
			TNT1 A 0 A_JumpIfInventory("Necronomicon", 1, 3)
			TNT1 A 0 A_GiveInventory("Necronomicon", 1)
			TNT1 A 0 A_GiveInventory("Darkmana", 50)
			stop
			TNT1 A 0 A_GiveInventory("Darkmana", 50)
			TNT1 A 0 A_SpawnItemEx("NecronomiconPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
actor NecronomiconPickupEmpty : NecronomiconPickup
{
	states
	{
		Pickup:
			TNT1 A 0 A_JumpIfInventory("Necronomicon", 1, 1)
			TNT1 A 0 A_GiveInventory("Necronomicon", 1)
			stop
			TNT1 A 0 A_SpawnItemEx("NecronomiconPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
ACTOR Necronomicon : Weapon 25020
{
	Tag "Necronomicon"
	Scale 0.5
//	Weapon.AmmoGive 50
	Weapon.AmmoUse 10
	Weapon.AmmoUse2 30
	Weapon.AmmoType "Darkmana"
	Weapon.AmmoType2 "Darkmana"
	+FLOATBOB
	States
	{
		Spawn:
			NCRO A 0
			NCRO A 1 A_SpawnItem("NecronomiconPickup")
			Stop
		Ready: 
			TNT1 A 0 A_JumpIfInventory("DropAmmo",1,"DropAmmo_Start")
			TNT1 A 0 A_JumpIfInventory("DropWeapon",1,"DropWeapon_Start")
			NECR A 1 A_WeaponReady 
			Loop
		Deselect: 
			NECR A 1 A_Lower 
			Loop
		Select: 
			NECR A 1 A_Raise 
			Loop
		Fire:
			NECR A 0 A_JumpIfNoAmmo(1) 
			NECR A 30 A_Playsound("weapons/incant")
			NECR B 10
			NECR C 8
			NECR D 2
			NECR E 16 A_FireCustomMissile("VileField_Start", 0, 1, 0, 0)
//			NECR E 16 A_FireCustomMissile("GhostEgg", 0, 1, 0, 0)
			NECR D 4
			NECR C 4
			NECR B 4
			NECR A 4
			Goto Ready
		AltFire:
			NECR A 0 A_JumpIfNoAmmo(1) 
			NECR A 30 A_Playsound("weapons/incant")
			NECR B 10
			NECR C 8
			NECR D 0 //A_FireCustomMissile("GhostEgg3", 0, 1, -80, 0)
			NECR D 2 //A_FireCustomMissile("GhostEgg3", 0, 1, 80, 0)
			NECR E 0 A_FireCustomMissile("SpawnOwnMonster", 0, 1, 0, 0)
			NECR E 16 //A_FireCustomMissile("GhostEgg2", 0, 1, 0, 0)
			NECR D 4
			NECR C 4
			NECR B 4
			NECR A 4
			NECR A 0
			Goto Ready
/* **********          Drop Ammo          ********** */
		DropAmmo_Start:
			TNT1 A 0 A_TakeInventory("DropAmmo", 1)
			TNT1 A 0 A_JumpIfInventory("Darkmana", 6, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("Darkmana", 6)
			TNT1 A 0 A_SpawnItemEx("SmallDarkmana", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			goto Ready
/* **********          Drop Weapon          ********** */
		DropWeapon_Start:
			TNT1 A 0 A_TakeInventory("DropWeapon", 1)
			TNT1 A 0 A_JumpIfInventory("Necronomicon", 1, 1) // is weapon in inventory?
			goto Ready
			TNT1 A 0 A_SpawnItemEx("NecronomiconPickupEmpty", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			TNT1 A 1 A_TakeInventory("Necronomicon", 1)
			goto Deselect+1
	}
}
//************************************************************
ACTOR VileField_Start //Healer start
{
	PROJECTILE
	+NOGRAVITY +FRIENDLY +RIPPER +BLOODLESSIMPACT
	RENDERSTYLE NONE
	Radius 8 Height 8 Speed 160
	Damage 0
	States
	{
		Spawn:
			TNT1 A 1
			loop
		Death:
			TNT1 A 1 A_SpawnItem("VileFieldSpawner")
			Stop
	}
}
ACTOR VileFieldSpawner
{
	PROJECTILE
	+NOGRAVITY +RIPPER +BLOODLESSIMPACT +FLOORHUGGER +FLOORCLIP
	RENDERSTYLE NONE
	Radius 3 Height 3 Speed 12
	States
	{
		Spawn:
			TNT1 A 0
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 0)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 16)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 32)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 48)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 64)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 80)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 96)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 112)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 128)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 144)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 160)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 176)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 192)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 208)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 224)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 240)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 256)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 272)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 288)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 304)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 320)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 336)
			TNT1 A 0 A_CustomMissile("VileField", 0, Random(-4, 4), 352)
			Goto Death
		Death:
			TNT1 A 0
			Stop
	}
}
ACTOR VileField //Necronomicon
{
	PROJECTILE
	+FRIENDLY +NOCLIP +RIPPER +BLOODLESSIMPACT
	RENDERSTYLE NONE
	Radius 32 Height 5 Speed 7
	States
	{
	Spawn:
		TNT1 AAAAA 6 A_VileChase
		Stop
	Death:
		TNT1 A 1
		Stop
	Heal:
		TNT1 A 1
		Stop 
	}
}
//************************************************************
ACTOR SpawnOwnMonster //Necronomicon
{
	+FRIENDLY +FLOAT +LOOKALLAROUND +NOBLOCKMONST +NOGRAVITY
	RENDERSTYLE NONE
	Radius 10 Height 20 Speed 16
	States
	{
		Spawn:
			TNT1 A 7
			Goto Death
		Death:
			TNT1 A 4
			TNT1 A 4 A_SpawnItem("Bormereth_Friendly", 1, 0, 0)
			Stop
	}
}      
