//  ********************************************************
//  ***  Ammo: Magnum Ammo                               ***
//  ***  By: Cobalt and Butcher                          ***
//  ********************************************************
ACTOR MagnumBullets : Ammo
{
	Inventory.Amount 0
	Inventory.MaxAmount 12
	Ammo.BackpackAmount 0
	Ammo.BackpackMaxAmount 12
	States
	{
		Spawn:
			REVI I -1
			Stop
	}
}
//  ********************************************************
//  ***  Weapon: Magnum (Desert Eagle)                   ***
//  ***  By: Cobalt and Butcher                          ***
//  ********************************************************
actor MagnumGunPickup : CustomInventory
{
	Scale 0.26
	Inventory.PickupSound "misc/W_pkup"
	Inventory.PickUpMessage "You got the Magnum!"
	states
	{
		Spawn:
			EAG1 Z -1
			Loop
		Pickup:
			TNT1 A 0 A_JumpIfInventory("Magnum", 1, 3)
			TNT1 A 0 A_GiveInventory("Magnum", 1)
			TNT1 A 0 A_GiveInventory("MagnumBullets", 12)
			stop
			TNT1 A 0 A_GiveInventory("Clip", 12)
			TNT1 A 0 A_SpawnItemEx("MagnumGunPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
actor MagnumGunPickupEmpty : MagnumGunPickup
{
	states
	{
		Pickup:
			TNT1 A 0 A_JumpIfInventory("Magnum", 1, 1)
			TNT1 A 0 A_GiveInventory("Magnum", 1)
			stop
			TNT1 A 0 A_SpawnItemEx("MagnumGunPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
ACTOR Magnum : Weapon 25030
{
	Tag "Pistol"
	Scale 0.26
	weapon.selectionorder 999
	Weapon.AmmoType "MagnumBullets" 
	Weapon.AmmoType2 "Clip" 
	AttackSound "weapons/magnum"
	States
	{
		Spawn:
			EAG1 Z 1
			EAG1 Z 0 A_SpawnItem("MagnumGunPickup")
			Stop
		Ready:
//			TNT1 A 0 A_JumpIfInventory("ThrowGrenade",1,"ThrowGrenade_Start")
//			TNT1 A 0 A_JumpIfInventory("NextGrenadeCancel",1,"ThrowGrenade_Start")
//			TNT1 A 0 A_JumpIfInventory("GrenadeDetonator",1,"ThrowGrenade_Start")
			TNT1 A 0 A_JumpIfInventory("Reload",1,"Reload_Start")
			TNT1 A 0 A_JumpIfInventory("Unload",1,"Unload_Start")
			TNT1 A 0 A_JumpIfInventory("DropAmmo",1,"DropAmmo_Start")
			TNT1 A 0 A_JumpIfInventory("DropWeapon",1,"DropWeapon_Start")
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 1, 1)
			goto MagnumEmpty
			EAG1 A 1 A_WeaponReady
			Loop
		MagnumEmpty:
			EAG2 A 1 A_WeaponReady
			goto Ready
		Deselect:
			EAG1 A 1 A_Lower
			EAG1 A 0
			Loop
		Select:
			EAG1 A 1 A_Raise
			Loop
		Fire:
			TNT1 A 0
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 1, 2) // Wenn genug (Ammo Magazin), dann zur Aktion gehen
			EAG2 A 6 A_PlaySound("weapons/magnum/noammo") // No (Ammo Magazin) Sound (no Ammo)
			goto Ready
			TNT1 A 0 // Aktion
			TNT1 A 0 A_TakeInventory("MagnumBullets", 1) // Eins von (Ammo Magazin) nehmen
//  	... fire code ... 
			EAG1 A 0 A_FireCustomMissile("CasingBullet_x",300+random(-16,16),0,3,6)
			TNT1 A 0 A_GunFlash
			EAG1 A 2 bright A_FireBullets (1, 1, 1, 12, "BulletPuff", 1)//A_FireBullets(4, 4, 1, 8, 0, 1, 10240)
			EAG1 BCDEFG 2 bright
			EAG1 A 0 A_ReFire
			goto Ready
		AltFire:
			TNT1 A 0
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 1, 2) // Wenn genug (Ammo Magazin), dann zur Aktion gehen
			EAG2 A 6 A_PlaySound("weapons/magnum/noammo") // No (Ammo Magazin) Sound (no Ammo)
			goto Ready
			TNT1 A 0 // Aktion
			TNT1 A 0 A_TakeInventory("MagnumBullets", 1) // Eins von (Ammo Magazin) nehmen
//  	... fire code ... 
			EAG1 A 0 A_FireCustomMissile("CasingBullet_x",300+random(-16,16),0,3,6)
			TNT1 A 0 A_GunFlash
			EAG1 A 1 bright A_FireBullets (3, 3, 1, 12, "BulletPuff", 1)
			EAG1 BCDEFG 1 bright
			EAG1 A 0 A_ReFire
			goto Ready
/* **********          Reload          ********** */
		Reload_Start:
			TNT1 A 0 A_TakeInventory("Reload", 1)
			TNT1 A 0 A_JumpIfInventory("Clip", 1, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 12, "Ready") // magazine full
			EAG2 A 3
			EAG2 B 3 A_PlaySound("weapons/AK47/reload1")
			EAG2 CDEFGHI 3
			EAG2 J 3 A_PlaySound("weapons/AK47/reload2")
			EAG2 K 3
			EAG2 L 3 A_PlaySound("weapons/AK47/reload3")
			EAG2 MNO 3
		Reload_Transfer:// Ammo Transfer [load weapon] (:zu diesem Zeitpunkt ist sichergestellt, dass mindestens 1 Ammo im Inventar vorhanden ist, und dass das Magazin nicht voll ist)
			TNT1 A 0 A_TakeInventory("Clip", 1)
			TNT1 A 0 A_GiveInventory("MagnumBullets", 1)
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 12, "Ready") //if magazine is full then ready
			TNT1 A 0 A_JumpIfInventory("Clip", 1, "Reload_Transfer") //loop to load the rest | Wenn noch was im Inventar da ist, weiterladen
//			goto Reload_End // Da keine Munition im Inventar mehr da ist, (Jump to Anim2 [ready])
		Reload_End: // end animation of reloading
			TNT1 A 0 // (JumpPoint ready Laden [Anim2])
			goto Ready
/* **********          Unload          ********** */
		Unload_Start:
			TNT1 A 0 A_TakeInventory("Unload", 1)
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 1, 1) // is ammo in magazine?
			goto Ready
			EAG2 A 3//ABCDEFGHIJ | K JIHGFE DCBA
			EAG2 B 3 A_PlaySound("weapons/AK47/reload1")
			EAG2 CDEF 3
			EAG2 E 3 //A_PlaySound("weapons/AK47/reload2")
			EAG2 DCBA 3
		Unload_Transfer: // Ammo Transfer [Entladen]
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 1, 1) // is ammo in magazine? Wenn im Magazin noch mindestens ein Ammo drin ist, dann zum (Ammo Transfer (Entladen)) springen
			goto Unload_End // magazine is empty -> End Unload Sequence
			TNT1 A 0 A_TakeInventory("MagnumBullets", 1)
			TNT1 A 0 A_GiveInventory("Clip", 1)
			goto Unload_Transfer //loop to unload all
		Unload_End:
			TNT1 A 0
			goto Ready
/* **********          Reload          ********** */
		DropAmmo_Start:
			TNT1 A 0 A_TakeInventory("DropAmmo", 1)
			TNT1 A 0 A_JumpIfInventory("Clip", 12, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("Clip", 12)
			TNT1 A 0 A_SpawnItemEx("Clip_", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			goto Ready
		DropWeapon_Start:
			TNT1 A 0 A_TakeInventory("DropWeapon", 1)
			TNT1 A 0 A_JumpIfInventory("Magnum", 1, 1) // is weapon in inventory?
			goto Ready
			//Unload magazine start
			TNT1 A 0 A_JumpIfInventory("MagnumBullets", 1, 1) // is ammo in magazine?
			goto DropWeapon_Start+5 // magazine is empty -> Drop Weapon
			TNT1 A 0 A_TakeInventory("MagnumBullets", 1)
			TNT1 A 0 A_GiveInventory("Clip", 1)
			goto DropWeapon_Start+2 //loop to unload all
			//Unload magazine end
			TNT1 A 0 A_SpawnItemEx("MagnumGunPickupEmpty", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			TNT1 A 1 A_TakeInventory("Magnum", 1)
			goto Deselect+1
		Flash:
			EAG1 XY 1 bright
			Stop
	}
}
