//  ********************************************************
//  ***  Weapon: Photon Rifle                            ***
//  ***  By: TheDarkArchon                               ***
//  ***  Modified By: Cobalt and Butcher                 ***
//  ********************************************************
actor PhotonRiflePickup : CustomInventory
{
	Scale 0.5
	Inventory.PickupSound "misc/W_pkup"
	Inventory.PickUpMessage "You got the Plasma Rifle!"
	states
	{
		Spawn:
			TRIG Z -1
			Loop
		Pickup:
			TNT1 A 0 A_JumpIfInventory("PhotonRifle", 1, 3)
			TNT1 A 0 A_GiveInventory("PhotonRifle", 1)
			TNT1 A 0 A_GiveInventory("Cell", 30)
			stop
			TNT1 A 0 A_GiveInventory("Cell", 30)
			TNT1 A 0 A_SpawnItemEx("PhotonRiflePickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
actor PhotonRiflePickupEmpty : PhotonRiflePickup
{
	states
	{
		Pickup:
			TNT1 A 0 A_JumpIfInventory("PhotonRifle", 1, 1)
			TNT1 A 0 A_GiveInventory("PhotonRifle", 1)
			stop
			TNT1 A 0 A_SpawnItemEx("PhotonRiflePickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
ACTOR PhotonRifle : Weapon 25080
{
	Tag "Plasmagun"
	Weapon.SelectionOrder 100
	Weapon.Kickback 1
	Weapon.AmmoType1 "Cell"
	Weapon.AmmoType2 "PhotonRifleHeat"
//	Weapon.AmmoGive 30
	Weapon.AmmoUse 1
	Obituary "%o was over-energized by %k's Photon Rifle"
	States
	{
		Spawn:
			TRIG Z 0
			TRIG Z 1 A_SpawnItem("PhotonRiflePickup")
			Stop
		Ready:
			TNT1 A 0 A_CheckReload
			TNT1 A 0 A_JumpIfInventory("DropAmmo",1,"DropAmmo_Start")
			TNT1 A 0 A_JumpIfInventory("DropWeapon",1,"DropWeapon_Start")
			TRIG A 1 A_WeaponReady
			TNT1 A 0 A_TakeInventory("PhotonRifleHeat",1)
			Loop
		Deselect:
			TRIG A 0 A_TakeInventory("PhotonRifleHeat",100) 
			TRIG A 1 A_Lower
			LOOP
		Select: 
			TRIG A 0 A_CheckReload
			TRIG A 1 A_Raise
			LOOP
		Fire:
			//TRIG ABCD 1 bright //*old
			TNT1 AA 0 //faster refire *new
			TRIG BD 1 bright//faster refire *new
			TRIF C 1 bright A_FireCustomMissile("PhotonBall",0,1,8,0)
			TRIG A 0 bright A_GiveInventory("PhotonRifleHeat",3)
			PRFG B 0 A_JumpIfInventory("PhotonRifleHeat",50,2) 
			PRFG B 0
			PRFG A 0 A_JumpIfInventory("PhotonRifleHeat",75,2)
			PRFG A 0
			PRFG A 0 A_JumpIfInventory("PhotonRifleHeat",100,1) 
			Goto Ready
			PRFG C 0 A_PlaySound("weapons/photonoverheat")
			PRFG C 0 A_FireCustomMissile("PhotonSmoke",0,0,1,6)	    
			TRIG D 1 A_TakeInventory("PhotonRifleHeat",1)
			PRFG C 0 A_JumpIfInventory("PhotonRifleHeat",1,1)
			Goto Ready
			PRFG C 0 
			Goto Fire+13
		AltFire:
			TNT1 A 0 A_JumpIfInventory("Cell",4,1)
			Goto ready
			TNT1 A 0 bright A_TakeInventory("Cell",4)
			//TRIG ABCD 2 bright //*old
			TRIG ABCD 1 bright//faster altfire refire *new
			TRIF C 3 bright A_FireCustomMissile("PhotonBall_big",0,1,8,0)
			PRFF C 0 bright A_GiveInventory("PhotonRifleHeat",10)
			TNT1 A 0 A_JumpIfInventory("PhotonRifleHeat",50,2) 
			TNT1 A 0
			TNT1 A 0 A_JumpIfInventory("PhotonRifleHeat",75,2)
			TNT1 A 0
			TNT1 A 0 A_JumpIfInventory("PhotonRifleHeat",100,1) 
			Goto Ready
			TNT1 A 0 A_PlaySound("weapons/photonoverheat")
			TNT1 A 0 A_FireCustomMissile("PhotonSmoke",0,0,1,6)	    
			TRIG D 1 A_TakeInventory("PhotonRifleHeat",1)
			TNT1 A 0 A_JumpIfInventory("PhotonRifleHeat",1,1)
			Goto Ready
			TNT1 A 0 
			Goto AltFire+15
		Flash:
			TNT1 A 1 A_Light2
			TNT1 A 1 A_Light1
			TNT1 A 0 A_Light0
			Stop
/* **********          Drop Ammo          ********** */
		DropAmmo_Start:
			TNT1 A 0 A_TakeInventory("DropAmmo", 1)
			TNT1 A 0 A_JumpIfInventory("Cell", 20, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("Cell", 20)
			TNT1 A 0 A_SpawnItemEx("Cell_", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			goto Ready
/* **********          Drop Weapon          ********** */
		DropWeapon_Start:
			TNT1 A 0 A_TakeInventory("DropWeapon", 1)
			TNT1 A 0 A_JumpIfInventory("PhotonRifle", 1, 1) // is weapon in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("PhotonRifleHeat", 100)
			TNT1 A 0 A_SpawnItemEx("PhotonRiflePickupEmpty", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			TNT1 A 1 A_TakeInventory("PhotonRifle", 1)
			goto Deselect+1
	}
}
