//  ********************************************************
//  ***  Weapon: Rocketlauncher                          ***
//  ***  By: Cobalt and Butcher                          ***
//  ********************************************************
actor RocketlauncherPickup : CustomInventory
{
	Scale 1.0
	Inventory.PickupSound "misc/W_pkup"
	Inventory.PickUpMessage "You got the Rocketlauncher!"
	states
	{
		Spawn:
			UBER ABCDEFGHI 3
			Loop
		Pickup:
			TNT1 A 0 A_JumpIfInventory("Rocketlauncher_", 1, 3)
			TNT1 A 0 A_GiveInventory("Rocketlauncher_", 1)
			TNT1 A 0 A_GiveInventory("RocketAmmo", 1)
			stop
			TNT1 A 0 A_GiveInventory("RocketAmmo", 1)
			TNT1 A 0 A_SpawnItemEx("RocketlauncherPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
actor RocketlauncherPickupEmpty : RocketlauncherPickup
{
	states
	{
		Pickup:
			TNT1 A 0 A_JumpIfInventory("Rocketlauncher_", 1, 1)
			TNT1 A 0 A_GiveInventory("Rocketlauncher_", 1)
			stop
			TNT1 A 0 A_SpawnItemEx("RocketlauncherPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
ACTOR Rocketlauncher_ : Weapon replaces Rocketlauncher // 2003
{
	Tag "Rocketlauncher"
	weapon.selectionOrder 2300
	Weapon.AmmoType1 "RocketAmmo"
//	Weapon.AmmoGive1 1
	Weapon.AmmoUse1 1
	Weapon.AmmoType2 "RocketAmmo"
//	Weapon.AmmoGive2 5
	Weapon.AmmoUse2 1
	States
	{
		Spawn:
			UBER A 0
			UBER A 1 A_SpawnItem("RocketlauncherPickup")
			Stop
		Ready:
			TNT1 A 0 A_JumpIfInventory("DropAmmo",1,"DropAmmo_Start")
			TNT1 A 0 A_JumpIfInventory("DropWeapon",1,"DropWeapon_Start")
			BARR A 1 A_WeaponReady
			Loop
		Deselect:
			BARR A 1 A_Lower
			TNT1 A 0
			Loop
		Select:
			BARR A 1 A_Raise
			TNT1 A 0
			Loop
		Fire:
			BARR A 0 A_CheckReload
			BARR A 2 A_FireCustomMissile("Rocket_alpha",0,1,9,-2)
			BARR B 2
			BARR C 4
			BARR B 2
			BARR A 26
			Goto Ready
		AltFire:
			BARR A 0 A_CheckReload
			BARF A 0 //A_TakeInventory("RocketAmmo", 1)
			BARR A 2 A_FireCustomMissile("Rocket_alpha_seeker",0,1,9,-2)
			BARR B 2
			BARR C 4
			BARR B 2
			BARR A 26
			Goto Ready
/* **********          Drop Ammo          ********** */
		DropAmmo_Start:
			TNT1 A 0 A_TakeInventory("DropAmmo", 1)
			TNT1 A 0 A_JumpIfInventory("RocketAmmo", 1, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("RocketAmmo", 1)
			TNT1 A 0 A_SpawnItemEx("RocketAmmo_", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			goto Ready
/* **********          Drop Weapon          ********** */
		DropWeapon_Start:
			TNT1 A 0 A_TakeInventory("DropWeapon", 1)
			TNT1 A 0 A_JumpIfInventory("Rocketlauncher_", 1, 1) // is weapon in inventory?
			goto Ready
			TNT1 A 0 A_SpawnItemEx("RocketlauncherPickupEmpty", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			TNT1 A 1 A_TakeInventory("Rocketlauncher_", 1)
			goto Deselect+1
	}
}
//  ********** Rocket normal **********
//  Rocketlauncher_
ACTOR Rocket_alpha : RocketBase//SFX_Rocket_alpha replaces Rocket_alpha// : ROCKET
{ 
	Spawnid 127
	States
	{
		Spawn:
			MISL A 1 bright
			loop
		Death: 
			TNT1 A 0 Radius_Quake(3, 28, 1, 4, 0)
			TNT1 A 0 A_Explode(230, 192)
			TNT1 A 0 A_SpawnItemEx("SFX_RocketExplosion", 0, 0, 0, 0, 0, 1, 0, 128 | SXF_NOCHECKPOSITION, 0)
			TNT1 A 20
			Stop
	}
}
//  ********** Rocket normal [seeker] **********
//  Rocketlauncher_
ACTOR Rocket_alpha_seeker : Rocket_alpha//SFX_Rocket_alpha_seeker : SFX_Rocket_alpha replaces Rocket_alpha_seeker
{ 
	+SEEKERMISSILE// +SCREENSEEKER
	States
	{
		Spawn:
			MISL A 0
			MISL A 1 A_SeekerMissile(90,90)
//QROK A 2 bright A_SeekerMissile(50,3)
//NULL A 0 A_CustomMissile("seekerRockTrail",0,0,0,0)
//QROK A 0 Bright A_LookEx(2,0,12,0,360,"See")
//	action native A_MStaffTrack();
//QROK A 0 Bright A_MStaffTrack
//QROK A 0 A_JumpIfCloser(10,"Death")
			Loop
		Death: 
			TNT1 A 0 A_Explode(230, 192)
			TNT1 A 0 Radius_Quake(3, 28, 1, 4, 0)
			TNT1 A 0 A_SpawnItemEx("SFX_RocketExplosion", 0, 0, 0, 0, 0, 1, 0, 128 | SXF_NOCHECKPOSITION, 0)
			TNT1 A 20
			Stop
	}
} 
