//  ********************************************************
//  ***  Ammo: MP5 Ammo                                  ***
//  ***  By: Cobalt and Butcher                          ***
//  ********************************************************
ACTOR MachineGunBullets : Ammo
{
	Inventory.Amount 0
	Inventory.MaxAmount 30
	Ammo.BackpackAmount 0
	Ammo.BackpackMaxAmount 30
//	Inventory.Icon REVII0
	States
	{
		Spawn:
			REVI I -1
			Stop
	}
}
//  ********************************************************
//  ***  Weapon: MP5                                     ***
//  ***  By: Cobalt and Butcher                          ***
//  ********************************************************
actor MachineGunPickup : CustomInventory
{
	Scale 0.3
	Inventory.PickupSound "misc/W_pkup"
	Inventory.PickUpMessage "You got the MP5!"
	states
	{
		Spawn:
			MP5_ Z -1
			Loop
		Pickup:
			TNT1 A 0 A_JumpIfInventory("MachineGun", 1, 3)
			TNT1 A 0 A_GiveInventory("MachineGun", 1)
			TNT1 A 0 A_GiveInventory("MachineGunBullets", 30)
			stop
			TNT1 A 0 A_GiveInventory("Clip", 30)
			TNT1 A 0 A_SpawnItemEx("MachineGunPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
actor MachineGunPickupEmpty : MachineGunPickup
{
	states
	{
		Pickup:
			TNT1 A 0 A_JumpIfInventory("MachineGun", 1, 1)
			TNT1 A 0 A_GiveInventory("MachineGun", 1)
			stop
			TNT1 A 0 A_SpawnItemEx("MachineGunPickupEmpty", 0, 0, 0, 1, 0, 1, 0, 0, 0)
			stop
	}
}
ACTOR MachineGun : Weapon replaces Chaingun // 2002
{
	Tag "MP5"
	Scale 0.3
	weapon.selectionorder 1600
	Weapon.AmmoType "MachineGunBullets" 
	Weapon.AmmoType2 "Clip" 
	AttackSound "weapons/AK47/shot"
	States
	{
		Spawn:
			MP5_ Z 1
			MP5_ Z 0 A_SpawnItem("MachineGunPickup")
			Stop
		Ready:
			TNT1 A 0 A_JumpIfInventory("Reload",1,"Reload_Start")
			TNT1 A 0 A_JumpIfInventory("Unload",1,"Unload_Start")
			TNT1 A 0 A_JumpIfInventory("DropAmmo",1,"DropAmmo_Start")
			TNT1 A 0 A_JumpIfInventory("DropWeapon",1,"DropWeapon_Start")
			MP5_ A 1 A_WeaponReady
			Loop
		Deselect:
			MP5_ A 1 A_Lower
			MP5_ A 0
			Loop
		Select:
			MP5_ A 1 A_Raise
			Loop
		Fire:
			TNT1 A 0
			TNT1 A 0 A_JumpIfInventory("MachineGunBullets", 1, 2) // Wenn genug (Ammo Magazin), dann zur Aktion gehen
			MP5_ A 6 A_PlaySound("weapons/magnum/noammo") // No (Ammo Magazin) Sound (no Ammo)
			goto Ready
			TNT1 A 0 // Aktion
			TNT1 A 0 A_TakeInventory("MachineGunBullets", 1) // Eins von (Ammo Magazin) nehmen
//  	... fire code ... 
			MP5_ A 0 A_FireCustomMissile("CasingBullet_x",300+random(-16,16),0,3,6)
			MP5_ A 2 A_FireBullets (1, 1, 1, 8, "BulletPuff", 1)
			MP5_ B 2
			MP5_ A 0 A_ReFire
			goto Ready
/* **********          Reload          ********** */
		Reload_Start:
			TNT1 A 0 A_TakeInventory("Reload", 1)
			TNT1 A 0 A_JumpIfInventory("Clip", 1, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_JumpIfInventory("MachineGunBullets", 30, "Ready") // magazine full
			MP5R ABCD 3
			MP5R E 3 A_PlaySound("weapons/AK47/reload1")
			MP5R FGHIJKJIHGF 3//****3D -> MP5R FGHIJ 3
			MP5R E 3 A_PlaySound("weapons/AK47/reload2")//****3D -> MP5R K 3 A_PlaySound("weapons/AK47/reload2")
			MP5R LMNO 3
			MP5R P 3 A_PlaySound("weapons/AK47/reload3")
			MP5R QRST 3
			MP5R AAAA 0 //ABCDEFGHIJ | K JIHGFE LMNOPQRST
		Reload_Transfer:// Ammo Transfer [load weapon] (:zu diesem Zeitpunkt ist sichergestellt, dass mindestens 1 Ammo im Inventar vorhanden ist, und dass das Magazin nicht voll ist)
			TNT1 A 0 A_TakeInventory("Clip", 1)
			TNT1 A 0 A_GiveInventory("MachineGunBullets", 1)
			TNT1 A 0 A_JumpIfInventory("MachineGunBullets", 30, "Ready") //if magazine is full then ready
			TNT1 A 0 A_JumpIfInventory("Clip", 1, "Reload_Transfer") //loop to load the rest | Wenn noch was im Inventar da ist, weiterladen
//			goto Reload_End // Da keine Munition im Inventar mehr da ist, (Jump to Anim2 [ready])
		Reload_End: // end animation of reloading
			TNT1 A 0 // (JumpPoint ready Laden [Anim2])
			goto Ready
/* **********          Unload          ********** */
		Unload_Start:
			TNT1 A 0 A_TakeInventory("Unload", 1)
			TNT1 A 0 A_JumpIfInventory("MachineGunBullets", 1, 1) // is ammo in magazine?
			goto Ready
			MP5R ABCD 3//ABCDEFGHIJ | K JIHGFE DCBA
			MP5R E 3 A_PlaySound("weapons/AK47/reload1")
			MP5R FGHIJKJIHGF 3
			MP5R E 3 A_PlaySound("weapons/AK47/reload2")
			MP5R DCB 3
		Unload_Transfer: // Ammo Transfer [Entladen]
			TNT1 A 0 A_JumpIfInventory("MachineGunBullets", 1, 1) // is ammo in magazine? Wenn im Magazin noch mindestens ein Ammo drin ist, dann zum (Ammo Transfer (Entladen)) springen
			goto Unload_End // magazine is empty -> End Unload Sequence
			TNT1 A 0 A_TakeInventory("MachineGunBullets", 1)
			TNT1 A 0 A_GiveInventory("Clip", 1)
			goto Unload_Transfer //loop to unload all
		Unload_End:
			TNT1 A 0
			goto Ready
/* **********          Drop Ammo          ********** */
		DropAmmo_Start:
			TNT1 A 0 A_TakeInventory("DropAmmo", 1)
			TNT1 A 0 A_JumpIfInventory("Clip", 12, 1) // is ammo in inventory?
			goto Ready
			TNT1 A 0 A_TakeInventory("Clip", 12)
			TNT1 A 0 A_SpawnItemEx("Clip_", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			goto Ready
/* **********          Drop Weapon          ********** */
		DropWeapon_Start:
			TNT1 A 0 A_TakeInventory("DropWeapon", 1)
			TNT1 A 0 A_JumpIfInventory("MachineGun", 1, 1) // is weapon in inventory?
			goto Ready
			//Unload magazine start
			TNT1 A 0 A_JumpIfInventory("MachineGunBullets", 1, 1) // is ammo in magazine?
			goto DropWeapon_Start+5 // magazine is empty -> Drop Weapon
			TNT1 A 0 A_TakeInventory("MachineGunBullets", 1)
			TNT1 A 0 A_GiveInventory("Clip", 1)
			goto DropWeapon_Start+2 //loop to unload all
			//Unload magazine end
			TNT1 A 0 A_SpawnItemEx("MachineGunPickupEmpty", 64, 0, 32, 5, 0, 5, 0, 0, 0)
			TNT1 A 1 A_TakeInventory("MachineGun", 1)
			goto Deselect+1
	}
}
